// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_navigation_msgs:msg/LaneBoundary.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__LANE_BOUNDARY__STRUCT_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__LANE_BOUNDARY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'line'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_navigation_msgs__msg__LaneBoundary __attribute__((deprecated))
#else
# define DEPRECATED__automotive_navigation_msgs__msg__LaneBoundary __declspec(deprecated)
#endif

namespace automotive_navigation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LaneBoundary_
{
  using Type = LaneBoundary_<ContainerAllocator>;

  explicit LaneBoundary_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->style = 0;
      this->color = 0;
    }
  }

  explicit LaneBoundary_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->style = 0;
      this->color = 0;
    }
  }

  // field types and members
  using _style_type =
    uint8_t;
  _style_type style;
  using _color_type =
    uint8_t;
  _color_type color;
  using _line_type =
    std::vector<geometry_msgs::msg::Point_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Point_<ContainerAllocator>>>;
  _line_type line;

  // setters for named parameter idiom
  Type & set__style(
    const uint8_t & _arg)
  {
    this->style = _arg;
    return *this;
  }
  Type & set__color(
    const uint8_t & _arg)
  {
    this->color = _arg;
    return *this;
  }
  Type & set__line(
    const std::vector<geometry_msgs::msg::Point_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Point_<ContainerAllocator>>> & _arg)
  {
    this->line = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t UNKNOWN =
    0u;
  static constexpr uint8_t SOLID =
    1u;
  static constexpr uint8_t DASHED =
    2u;
  static constexpr uint8_t SOLID_DASHED =
    3u;
  static constexpr uint8_t DASHED_SOLID =
    4u;
  static constexpr uint8_t SOLID_SOLID =
    5u;
  static constexpr uint8_t WHITE =
    1u;
  static constexpr uint8_t YELLOW =
    2u;

  // pointer types
  using RawPtr =
    automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_navigation_msgs__msg__LaneBoundary
    std::shared_ptr<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_navigation_msgs__msg__LaneBoundary
    std::shared_ptr<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LaneBoundary_ & other) const
  {
    if (this->style != other.style) {
      return false;
    }
    if (this->color != other.color) {
      return false;
    }
    if (this->line != other.line) {
      return false;
    }
    return true;
  }
  bool operator!=(const LaneBoundary_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LaneBoundary_

// alias to use template instance with default allocator
using LaneBoundary =
  automotive_navigation_msgs::msg::LaneBoundary_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t LaneBoundary_<ContainerAllocator>::UNKNOWN;
template<typename ContainerAllocator>
constexpr uint8_t LaneBoundary_<ContainerAllocator>::SOLID;
template<typename ContainerAllocator>
constexpr uint8_t LaneBoundary_<ContainerAllocator>::DASHED;
template<typename ContainerAllocator>
constexpr uint8_t LaneBoundary_<ContainerAllocator>::SOLID_DASHED;
template<typename ContainerAllocator>
constexpr uint8_t LaneBoundary_<ContainerAllocator>::DASHED_SOLID;
template<typename ContainerAllocator>
constexpr uint8_t LaneBoundary_<ContainerAllocator>::SOLID_SOLID;
template<typename ContainerAllocator>
constexpr uint8_t LaneBoundary_<ContainerAllocator>::WHITE;
template<typename ContainerAllocator>
constexpr uint8_t LaneBoundary_<ContainerAllocator>::YELLOW;

}  // namespace msg

}  // namespace automotive_navigation_msgs

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__LANE_BOUNDARY__STRUCT_HPP_
